//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

canBePicked <- true;

OnCustomEvent("vip_death", 0, function(player, params)
{
    Enable();
});

function CaneThink()
{
    if (canBePicked)
        PickUpTick();
    return 0.1;
}

function PickUpTick()
{
    local frame = GetPropInt(self, "m_ubInterpolationFrame");
    self.SetAbsAngles(self.GetAbsAngles() + QAngle(0, 10, 0));
    SetPropInt(self, "m_ubInterpolationFrame", frame);

    local myPos = self.GetOrigin();
    foreach(player in GetAlivePlayers())
    {
        if (player.GetTeam() != self.GetTeam())
            continue;
        if ((myPos - player.GetCenter()).Length() < 75)
        {
            Disable();
            main_script.ConvertToVIP(player);
            return;
        }
    }
}

function OnPostSpawn()
{
    Enable();
}

function Enable()
{
    canBePicked = true;
    self.EnableDraw();

    EntFireByHandle(SpawnEntityFromTable("info_particle_system",
    {
        origin = self.GetOrigin() - Vector(0, 0, 20),
        effect_name = "spellbook_major_burning",
        start_active = 1
    }), "SetParent", "!activator", -1, self, self);
}

function Disable()
{
    canBePicked = false;
    self.DisableDraw();
    local entsToKill = [];
    for (local child = self.FirstMoveChild(); child != null; child = child.NextMovePeer())
    {
        printl("kill " + child);
        entsToKill.push(child);
    }
    foreach (ent in entsToKill)
        ent.Kill();
}