//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

::canes <- [null, null, null, null, null];
::vipPlayer <- null;
::vipDeathCounter <- 0;

function GetVIPPlayer()
{
    return vipPlayer;
}

function IsVIP(player)
{
    return player && vipPlayer == player;
}

function SpawnRedCaneAt(targetname)
{
    SpawnCaneAt(2, targetname);
}

function SpawnBlueCaneAt(targetname)
{
    SpawnCaneAt(3, targetname);
}
SpawnBluCaneAt <- SpawnBlueCaneAt;

function SpawnCaneAt(team, targetname)
{
    SpawnCaneAtEntity(team, Entities.FindByName(null, targetname));
}

function SpawnCaneAtEntity(team, entity)
{
    if (!entity || !entity.IsValid())
        return;
    if (canes[team] && canes[team].IsValid())
    {
        canes[team].Teleport(true, entity.GetOrigin(), false, QAngle(), false, Vector());
    }
    else
    {
	    canes[team] = SpawnEntityFromTable("prop_dynamic",
	    {
        	origin = entity.GetOrigin(),
            angles = "-20 0 0",
            model = API_GetString("cane_pickup_model"),
            vscripts = "vip/entities/cane_pickup.nut",
            thinkfunction = "CaneThink",
	        playbackrate = 1.0,
            TeamNum = team
        });
    }
};

IncludeScript("vip/vip/vip_spawn.nut");
IncludeScript("vip/vip/vip_buffs.nut");
IncludeScript("vip/vip/vip_headshot.nut");
IncludeScript("vip/vip/vip_nag.nut");
IncludeScript("vip/vip/vip_capture.nut");