//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

eventEntry <- OnCustomEvent("vip_death", 0, function(player, params)
{
    dispenser.Kill();
    trigger.Kill();
    self.Kill();
    RemoveListener(eventEntry);
});

dispenser <- null;
trigger <- null;

function OnPostSpawn()
{
    local dispenserName = "vip_" + UniqueString();

    trigger = SpawnEntityFromTable("dispenser_touch_trigger", {
        origin = self.GetOrigin(),
        targetname = dispenserName,
        spawnflags = 1,
        StartDisabled = 0
    });
    trigger.KeyValueFromInt("solid", 2);
    trigger.KeyValueFromString("mins", "-140 -140 -96");
    trigger.KeyValueFromString("maxs", "140 140 96");

    dispenser = SpawnEntityFromTable("pd_dispenser",
    {
        origin = self.GetOrigin(),
        teamnum = self.GetTeam(),
        touch_trigger = dispenserName
    })
}

function DispenserThink()
{
    local myPos = self.GetOrigin();
    trigger.SetAbsOrigin(myPos);
    local frame = GetPropInt(dispenser, "m_ubInterpolationFrame");
    dispenser.SetAbsOrigin(myPos);
    SetPropInt(dispenser, "m_ubInterpolationFrame", frame);
}