//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

function ShootGibs(origin, ...)
{
    local gibSpawner = SpawnEntityFromTable("env_shooter",
    {
        spawnflags = 5,
        m_iGibs = 1,
        m_flVelocity = 200,
        scale = 1,
        m_flVariance = 1,
        m_flGibLife = 5,
        shootsounds = 3,
        simulation = 1,
        skin = 1,
        nogibshadows = true
    })
    gibSpawner.SetAbsOrigin(origin);
    gibSpawner.SetAbsAngles(QAngle(-90, 0, 0));
    EntFireByHandle(gibSpawner, "Kill", "", 2, null, null);

    local gibLength = vargv.len();
    for(local i = 0; i < gibLength; i++)
    {
        EntFireByHandle(gibSpawner, "AddOutput", "shootmodel "+vargv[i], 0.1 * i, null, null);
        EntFireByHandle(gibSpawner, "Shoot", "", 0.1 * i, null, null);
    }
}

::ShakePoints <-  function()
{

}