//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

//!CompilePal::IncludeDirectory("models/vip")
//!CompilePal::IncludeDirectory("materials/models/vip")
//!CompilePal::IncludeDirectory("scripts/vscripts/__lizardlib")
//!CompilePal::IncludeDirectory("scripts/vscripts/vip")

ClearGameEventCallbacks();

::proxy_entities_global <- []
::overflow_alert <- false

try { IncludeScript("vip_addons/main_pre.nut"); } catch(e) { }

::API_DEF_VALUES <- {
    "vip_model": "models/vip/player/civilian/julius.mdl"
    "cane_pickup_model": "models/vip/weapons/c_models/c_cane/c_cane.mdl"
    "vip_hat_model": "models/vip/player/civilian/julius_hat.mdl"
    "hat_gib": "models/vip/player/gibs/gibs_civilianhat_blue.mdl"
    "umbrella_model": "models/vip/weapons/c_models/c_cane/c_cane.mdl"
    "vip_arms_model": "models/vip/weapons/c_models/c_civilian_arms.mdl"
}

IncludeScript("__lizardlib/_lizardlib.nut");

PrecacheModel(API_GetString("vip_model"));
PrecacheModel(API_GetString("vip_arms_model"));
PrecacheModel(API_GetString("umbrella_model"));

IncludeScript("vip/vip/_vip.nut");
IncludeScript("vip/gamemode/_gamemode.nut");

IncludeScript("vip/maintenance.nut");

try { IncludeScript("vip_addons/main.nut"); } catch(e) { }

__CollectGameEventCallbacks(this);
__CollectEventCallbacks(this, "OnGameEvent_", "GameEventCallbacks", RegisterScriptGameEventListener);