//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

vipBoostTokensStart <- 3;
vipBoostTokens <- 3;
pressedAttack2 <- false;
pressedReload <- false;
selectedBuffType <- 0;
lastTimeUsedOn <- 0;
lastPlayerUsedOn <- 0;
::counter <- 0;
pointPos <- null;

PrecacheScriptSound("Player.DenyWeaponSelection")
PrecacheScriptSound("WeaponMedigun_Vaccinator.Toggle")
PrecacheScriptSound("Player.HitSoundRetro")
PrecacheScriptSound("Player.DenyWeaponSelection")

game_text_vip_boost <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 5,
    holdtime = 5,
    message = "",
    x = -1,
    y = 0.6
});

AddTimer(-1, 0, function()
{
    local vip = GetVIPPlayer();
    if (!vip)
        return;
    local buttons = GetPropInt(vip, "m_nButtons");

    if (RandomInt(0, 20) == 0)
    {
        pointPos = null;
        counter = 0;
        for (local point; point = Entities.FindByClassname(point, "team_control_point");)
        {
            if (point.GetTeam() == TF_TEAM_RED)
            {
                local pointOrigin = point.GetOrigin();
                foreach (player in GetAlivePlayers())
                {
                    if (player.GetTeam() == TF_TEAM_BLUE && (player.GetOrigin() - pointOrigin).Length2D() < 400 && !IsVIP(player))
                        counter++;
                }
                if (counter >= 2)
                    pointPos = pointOrigin;
            }
        }
    }

    SetPropInt(vip, "m_Shared.m_bShieldEquipped", 0);
    local selectedBuffTypeStr = selectedBuffType == 0 ? "Mini-Crits" : selectedBuffType == 1 ? "Speed Boost" : "Damage Res."
    EntFireByHandle(game_text_vip_boost "AddOutput",
    "message (Reload) Selected buff∶ " + selectedBuffTypeStr
        +"\nBuff Tokens∶ " + vipBoostTokens
        +"\nPlayers near Point∶ "+counter
        +"\nPick up tokens from dead players", 0, vip, vip);
    EntFireByHandle(game_text_vip_boost "Display", "", 0, vip, vip);

    if (vip.IsUsingActionSlot()
        || (buttons & IN_ATTACK3)
        || (buttons & IN_RELOAD))
    {
        if (pressedReload)
            return;
        pressedReload = true;
        selectedBuffType++;
        EmitSoundOnClient("WeaponMedigun_Vaccinator.Toggle", vip);
        lastTimeUsedOn = 0;
        if (selectedBuffType > 2)
            selectedBuffType = 0;
    }
    else if (pressedReload)
        pressedReload = false;
    if (buttons & IN_ATTACK2)
    {
        if (pressedAttack2)
            return;
        else
        {
            pressedAttack2 = true;

            if (vipBoostTokens <= 0)
            {
                EmitSoundOnClient("Player.DenyWeaponSelection", vip);
                return;
            }

            local forward = vip.EyeAngles().Forward();
            local eyePos = vip.EyePosition();

            local trace = {
                start = eyePos,
                end = eyePos + forward * 2500,
                mask = Constants.FContents.CONTENTS_HITBOX|Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
                ignore = vip
            };
            TraceLineEx(trace);
            local target = safeget(trace, "enthit", worldspawn);
            if (target == worldspawn)
            {
                local trace = {
                    start = eyePos,
                    end = eyePos + forward * 2500,
                    mask = Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
                    ignore = vip
                };
                TraceLineEx(trace);
                target = safeget(trace, "enthit", null);
            }
            if (IsValidPlayer(target) && target.GetTeam() == TF_TEAM_VIP)
            {
                if (Time() - lastTimeUsedOn < 1.5 && lastPlayerUsedOn == target)
                    return;

                if (selectedBuffType == 0)
                    target.AddCondEx(TF_COND_OFFENSEBUFF, 8, vip);
                else if (selectedBuffType == 1)
                    target.AddCondEx(TF_COND_SPEED_BOOST, 8, vip);
                else
                    target.AddCondEx(TF_COND_DEFENSEBUFF, 8, vip);
                vipBoostTokens--;
                EmitSoundOnClient("Player.HitSoundRetro", vip);
                lastTimeUsedOn = Time();
                lastPlayerUsedOn = target;
            }
            else
                EmitSoundOnClient("Player.DenyWeaponSelection", vip);
        }
    }
    else if (pressedAttack2)
        pressedAttack2 = false;
});
