//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

capTriggerTimeStamps <- [0, 0, 0, 0, 0];

for (local trigger = null; trigger = Entities.FindByClassname(trigger, "trigger_capture_area");)
{
    EntityOutputs.AddOutput(trigger,
        "OnStartTouch",
        "!self",
        "RunScriptCode",
        "main_script.OnVIPStartTounch(activator, self)",
        0, -1);
    EntityOutputs.AddOutput(trigger,
        "OnEndTouch",
        "!self",
        "RunScriptCode",
        "main_script.OnVIPEndTounch(activator, self)",
        0, -1);
    trigger.KeyValueFromString("filtername", "captrigger_filter");
}

function OnVIPStartTounch(vip, trigger)
{
    if (!IsVIP(vip) || Time() - capTriggerTimeStamps[vip.GetTeam()] < 0.5)
        return;

    capTriggerTimeStamps[vip.GetTeam()] = Time();
    foreach(player in GetAllClients())
    {
        if (player.GetTeam() == vip.GetTeam() && player != vip)
            player.KeyValueFromString("targetname", "capturer");
    }
    EntFireByHandle(trigger, "Disable", "", -1, null, null);
    EntFireByHandle(trigger, "Enable", "", 0.01, null, null);
}

function OnVIPEndTounch(vip, trigger)
{
    if (!IsVIP(vip) || Time() - capTriggerTimeStamps[vip.GetTeam()] < 0.5)
        return;

    capTriggerTimeStamps[vip.GetTeam()] = Time();
    foreach(player in GetAllClients())
    {
        if (player.GetTeam() == vip.GetTeam() && player != vip)
            player.KeyValueFromString("targetname", "");
    }
    EntFireByHandle(trigger, "Disable", "", -1, null, null);
    EntFireByHandle(trigger, "Enable", "", 0.01, null, null);
}