//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

PrecacheScriptSound("Bullets.DefaultNearmiss");
PrecacheScriptSound("Weapon_mittens.CritHit");

::headshotProtection <- true;
PrecacheModel(API_GetString("hat_gib"));

OnGameHook("OnTakeDamage", 0, function(_, params)
{
    if (!headshotProtection || params.damage_custom != TF_DMG_CUSTOM_HEADSHOT || !IsVIP(params.const_entity))
        return;
    local vip = params.const_entity;
    headshotProtection = false;
    DispatchParticleEffect("miss_text", vip.EyePosition(), Vector());
    if (params.attacker !=  null)
    {
        EmitSoundOnClient("Bullets.DefaultNearmiss", params.attacker);
        EmitSoundOnClient("Weapon_mittens.CritHit", params.attacker);
    }
    params.damage = 1;
    params.early_out = true;
    ShootGibs(vip.GetOrigin(), API_GetString("hat_gib"));
    DoEntFire("civ_model_hat", "Kill", "", -1, null, null);
});