vipMiniCritBoostTime <- Time();
PrecacheScriptSound("Player.DenyWeaponSelection")

game_text_vip_boost <- SpawnEntityFromTable("game_text",
{
    color = "236 227 203",
    color2 = "0 0 0",
    channel = 5,
    holdtime = 5,
    message = "0asd",
    x = -1,
    y = 0.6
});

AddListener("tick", 0, function (deltaTime)
{
    local vip = GetVIPPlayer();
    if (!vip)
        return;
    local timeleft = vipMiniCritBoostTime - Time();
    local timeleftStr = "";
    if (timeleft <= 0)
        timeleftStr = "Ready";
    else
        timeleftStr = format("%ds", timeleft + 1);
    SetPropInt(vip, "m_Shared.m_bShieldEquipped", 0);
    DoEntFire("game_text", "AddOutput", "message Mini-Crit Boost∶ "+timeleftStr, 0, vip, vip);
    DoEntFire("game_text", "Display", "", 0, vip, vip);

    if ((GetPropInt(vip, "m_nButtons") & IN_ATTACK2))
    {
        if (timeleft <= 1)
        {
            local forward = vip.EyeAngles().Forward();
            local eyePos = vip.EyePosition();

            local trace = {
                start = eyePos,
                end = eyePos + forward * 500,
                mask = Constants.FContents.CONTENTS_SOLID|Constants.FContents.CONTENTS_MOVEABLE|Constants.FContents.CONTENTS_PLAYERCLIP|Constants.FContents.CONTENTS_WINDOW|Constants.FContents.CONTENTS_GRATE|Constants.FContents.CONTENTS_MONSTER,
                ignore = vip
            };
            TraceLineEx(trace);
            if ("enthit" in trace && IsValidPlayer(trace.enthit) && trace.enthit.GetTeam() == TF_TEAM_VIP)
            {
                trace.enthit.AddCondEx(TF_COND_OFFENSEBUFF, 8, vip);
                vipMiniCritBoostTime = Time() + 8;
            }
            else
                EmitSoundOnClient("Player.DenyWeaponSelection", vip);
        }
        else
            EmitSoundOnClient("Player.DenyWeaponSelection", vip);
    }
    /*foreach (player in GetAlivePlayers())
    {
        if (player.GetTeam() == TF_TEAM_VIP && player != vip)
        {
        }
    }*/
});

AddListener("damage_hook", 0, function (attacker, victim, params)
{
    if (victim.GetTeam() != TF_TEAM_VIP)
        return;
    local vip = GetVIPPlayer();
    if (!vip)
        return;
    if ((vip.GetOrigin() - victim.GetOrigin()).Length() > 160)
        return;
    params.damage *= 0.8;
});

::forward_spawn <- null;

function SetFlagForwardSpawn(name)
{
    forward_spawn = Entities.FindByName(null, name);
}

function TeleportFlagToForwardSpawn()
{
    EntFireByHandle(bomb_lmm_follower, "SetParent", "!activator", 0, worldspawn, worldspawn);
    bomb_lmm_follower.SetOrigin(bomb.GetCenter());
    EntFireByHandle(bomb_lmm_follower, "SetParent", "!activator", 0, worldspawn, worldspawn);
    if (forward_spawn)
        bomb.Teleport(true, forward_spawn.GetOrigin(), false, QAngle(), false, Vector());
}